FunXgame/FunXgame/Controllers/ImagenesController.cs
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FunXgame.Models;

namespace FunXgame.Controllers
{
    
    public class ImagenesController : Controller
    {
        db_FunXGameEntities db = new db_FunXGameEntities();
        // GET: Imagenes
        //IMAGENES
        public ActionResult ListarImagen()
        {
            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }
            ViewBag.grupoImagen = new SelectList(db.Grupo_Imagen, "Id_grupo", "Nombre_grupo");

            return View();
        }
        
        public ActionResult ListarImagenPartial(int? id, string nombre, int? grupo)
        {
            if (nombre == "")
            {
                nombre = null;
            }

            var lista = db.Imagen.ToList();

            if (id != null)
            {
                lista = lista.Where(d => d.Id_imagen == id).ToList();
            }

            if (nombre!=null)
            {
                lista = lista.Where(d => d.Nombre_imagen.ToLower() == nombre.ToLower()).ToList();
            }

            if (grupo != null)
            {
                lista = lista.Where(d => d.Id_grupo == grupo).ToList();
            }
            return PartialView("_ListarImagenPartial", lista);
        }

        //----------------------------------------->CREACION<------------------------------------//
        public ActionResult CrearImagen()
        {
            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }
            ViewBag.Id_grupo = new SelectList(db.Grupo_Imagen, "Id_grupo", "Nombre_grupo");
            return View();
        }

        [HttpPost]
        public ActionResult CrearImagen(Imagen img, HttpPostedFileBase Ruta)
        {
            ViewBag.Id_grupo = new SelectList(db.Grupo_Imagen, "Id_grupo", "Nombre_grupo");
            try
            {
                string fileName = "";

                if (img.Ruta != null)
                {
                    string extension = Path.GetExtension(Ruta.FileName);
                    fileName = img.Nombre_imagen + extension;
                    img.Ruta = "~/Content/Assets/Imagenes/" + fileName;
                    fileName = Path.Combine(Server.MapPath("~/Content/Assets/Imagenes/"), fileName);
                    Ruta.SaveAs(fileName);

                    db.Imagen.Add(img);
                    db.SaveChanges();
                }
            }
            catch (Exception)
            {
                return Redirect(Url.Content("~/Imagenes/CrearImagen/"));
            }

            return View();
        }
        [HttpPost]
        public ActionResult ExisteImagen(string Nombre_imagen)
        {

            if (!string.IsNullOrEmpty(Nombre_imagen))
            {
                var p = db.Imagen.FirstOrDefault(d => d.Nombre_imagen.ToLower().Equals(Nombre_imagen.ToLower()));
                if (p != null)
                {
                    return Json(p.Nombre_imagen);
                }
            }
            return Json("");
        }

        ////////////////////////////////////////////////-> EDITAR<-//////////////////////////////////////////////////////////

        public ActionResult EditarImagen(int? id)
        {
            var lista = db.Imagen.Where(d => d.Id_imagen == id).ToList();
            if (lista.Count == 0)
            {
                return Redirect(Url.Content("~/Imagenes/ListarImagen/"));
            }
            if (id != null)
            {
                Imagen img = db.Imagen.Find(id);
                ViewBag.Id_grupo = new SelectList(db.Grupo_Imagen, "Id_grupo", "Nombre_grupo", img.Id_grupo);
                return View(img);
            }

            return Redirect(Url.Content("~/Imagenes/ListarImagen/"));
        }

        [HttpPost]
        public ActionResult EditarImagen(Imagen img, HttpPostedFileBase Ruta, string Id_Imagen, string Nombre_imagen)
        {
            
            if (img.Ruta == null)
            {
                string rutaActual = "";
                string nuevaRuta = "";
                using (db_FunXGameEntities db2 = new db_FunXGameEntities())
                {
                    int id = int.Parse(Id_Imagen);
                    Imagen imagen = db2.Imagen.Find(id);
                    rutaActual = imagen.Ruta;
                    if (System.IO.File.Exists(Server.MapPath(rutaActual)))
                    {
                        //A ESTO LE FALTA UN TRY CATCH....-> segun yo.....
                        string extension = Path.GetExtension(rutaActual);
                        nuevaRuta = "~/Content/Assets/Imagenes/" + img.Nombre_imagen + extension;
                        System.IO.File.Move(Server.MapPath(rutaActual), Server.MapPath(nuevaRuta));
                    }
                }
                img.Ruta = nuevaRuta;
                db.Entry(img).State = EntityState.Modified;
                db.SaveChanges();
                return Redirect(Url.Content("~/Imagenes/ListarImagen/"));
            }
            
            if (img.Ruta != null)
            {
                string rutaActual = "";
                //string nuevaRuta = "";

                using (db_FunXGameEntities db2 = new db_FunXGameEntities())
                {
                    int id = int.Parse(Id_Imagen);
                    Imagen imagen = db2.Imagen.Find(id);
                    rutaActual = imagen.Ruta;
                    if (System.IO.File.Exists(Server.MapPath(rutaActual)))
                    {
                        string extension1 = Path.GetExtension(rutaActual);
                        System.IO.File.Delete(Server.MapPath(rutaActual));
                        string fileName = "";
                        string extension2 = Path.GetExtension(Ruta.FileName);
                        string nombreImg = Nombre_imagen;
                        fileName = img.Nombre_imagen + extension2;
                        img.Ruta = "~/Content/Assets/Imagenes/" + fileName;
                        fileName = Path.Combine(Server.MapPath("~/Content/Assets/Imagenes/"), fileName);
                        Ruta.SaveAs(fileName);
                        img.Nombre_imagen = nombreImg;                       
                    }
                }
                db.Entry(img).State = EntityState.Modified;
                db.SaveChanges();
            }
            return Redirect(Url.Content("~/Imagenes/ListarImagen/"));

        }

        [HttpPost]
        public ActionResult ExisteImagenEditar(string Nombre_imagen, string Id_imagen)
        {
            int id = int.Parse(Id_imagen);
            var img = db.Imagen.Where(d => d.Id_imagen == id && d.Nombre_imagen.Equals(Nombre_imagen)).FirstOrDefault();
            if (img != null)
            {
                if (img.Id_imagen == id && img.Nombre_imagen == Nombre_imagen) //->si es la misma imagen no te preocupes por el nombre
                {
                    return Json("");
                }
            }
            var p = db.Imagen.FirstOrDefault(d => d.Nombre_imagen.ToLower().Equals(Nombre_imagen.ToLower()));
            if (p != null)
            {
                return Json(p.Nombre_imagen);
            }
            else
            {
                return Json("");
            }
        }

        ////////////////////////////////////////////////-> ELIMINAR<-//////////////////////////////////////////////////////////
        [HttpPost]
        public ActionResult EliminarImagen(int id)
        {   
            Imagen imagen = db.Imagen.Find(id);
            //->validaciones cuando tenga marcas y productos asociados a las imagenes.....para que no se puedan borrar.
            try
            {
                string rutaActual = imagen.Ruta; //->ruta relativa = /~/ruta/otraruta
                if (System.IO.File.Exists(Server.MapPath(rutaActual)))
                {
                    db.Imagen.Remove(imagen);
                    db.SaveChanges();
                    System.IO.File.Delete(Server.MapPath(rutaActual));
                    return Json("");
                }
            }
            catch (Exception)
            {
                return Json("1");
            }
            return Json("1");
        }
    }

}

FunXgame/FunXgame/Views/Imagenes/CrearImagen.cshtml
@model FunXgame.Models.Imagen

@{
    ViewBag.Title = "CrearImagen";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">

    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}

    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Imagenes/ListarImagen">Listar imagenes</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link active" id="agregarImgNavLink" style="color:white; background-color:black" href="#">Agregar imagenes</a>
                    </li>
                </ul>
            </div>
            <div class="card-body text-left">
                @using (Html.BeginForm("CrearImagen", "Imagenes", FormMethod.Post, new { enctype = "multipart/form-data", id="imagenCrearForm" }))
                {
                    @Html.AntiForgeryToken()

                <div class="form-horizontal">


                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })


                    <div class="form-group">
                        <div class="col-md-10">
                            <img id=img src="~/Content/Assets/Imagenes/noImage.jpg" style="width:280px" />
                        </div>
                    </div>

                    @*<div class="form-group">
                        <img src="~/Content/Assets/Imagenes/noImage.jpg" id="img" style="width:300px" />
                    </div>*@

                    <div class="form-group">
                        <div class="col-md-10">
                            <input type="file" name="Ruta" id="Ruta" accept="image/*" class="form-control" onchange="vistaPrevia(event)" style="background-color:whitesmoke; border-color:whitesmoke" />
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Nombre imagen:</label>
                            @Html.EditorFor(model => model.Nombre_imagen, new { htmlAttributes = new { @class = "form-control", id = "Nombre_imagen" } })

                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Grupo de imagen:</label>
                            @Html.DropDownList("Id_grupo", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Grupo_imagen" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input type="submit" id="btnAgregarImg" value="Agregar imagen" class="btn btn-dark" />
                        </div>
                    </div>
                </div>
                }

            </div>
        </div>
    </div>
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script src="~/Scripts/FuncionesAll/imagen_vista_previa.js"></script>
    <script src="~/Scripts/Validaciones/valida_imagen.js"></script>

    <script>



        $(document).ready(function () {

            $('#Ruta').change(function () {
                var filename = $('input[type=file]').val().replace(/C:\\fakepath\\/i, '')
                filename = filename.split('.').shift();
                $('#Nombre_imagen').val(filename);
                validaNombreExiste();
            });

            $('#Nombre_imagen').blur(function () {
                validaNombreExiste();
                
            });
            enviaValidaImagen();
            limpiar();
            
        })
        function limpiar() {
            $('#Nombre_imagen').val('');
            $('#Grupo_imagen').val('');
        }

        function validaNombreExiste() {
            if ($('#Nombre_imagen').val().trim() != '') {
                    $.ajax({
                        type: 'POST',
                        url: '@Url.Action("ExisteImagen")',
                        data: '{Nombre_imagen:' + JSON.stringify($('#Nombre_imagen').val().trim()) + '}',
                        dataType: 'json',
                        contentType: 'application/json; charset=utf-8',
                        success: function (result) {
                            if (result != "") {
                                $('#Nombre_imagen').val('');
                                swal("Ya existe una imagen con ese nombre", "", "warning");
                            }
                        }
                    });
            }
        }
        

    </script>
}

FunXgame/FunXgame/Views/Imagenes/EditarImagen.cshtml
@model FunXgame.Models.Imagen
@{
    ViewBag.Title = "EditarImagen";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">

    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}

    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Imagenes/ListarImagen">Listar imagenes</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" style="color:black" href="~/Imagenes/CrearImagen">Agregar imagenes</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link active" style="color:white; background-color:black" href="#">Editar imagen</a>
                    </li>
                </ul>
            </div>
            <div class="card-body text-left">
                @using (Html.BeginForm("EditarImagen", "Imagenes", FormMethod.Post, new { enctype = "multipart/form-data", id = "imagenEditarForm" }))
                {
                    @Html.AntiForgeryToken()
                    <input type="hidden" name="Id_Imagen" id="Id_imagen" value="@Model.Id_imagen" />
                    <div class="form-horizontal">

                        @Html.ValidationSummary(true, "", new { @class = "text-danger" })


                        <div class="form-group">
                            <div class="col-md-10">
                                <img src="@Url.Content(Model.Ruta)" id="img" style="width:280px" />
                            </div>
                            
                        </div>

                       

                        <div class="form-group">
                            <div class="col-md-10">
                                <input type="file" name="Ruta" id="Ruta" accept="image/*" value="@Model.Ruta" class="form-control" onchange="vistaPrevia(event)" style="background-color:whitesmoke; border-color:whitesmoke" />
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-10">
                                <label>Nombre imagen:</label>
                                @Html.EditorFor(model => model.Nombre_imagen, new { htmlAttributes = new { @class = "form-control", id = "Nombre_imagen" } })

                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-10">
                                <label>Grupo de imagen:</label>

                                @Html.DropDownList("Id_grupo", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Grupo_imagen" })

                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-offset-2 col-md-10">
                                <input type="submit" id="btnEditarImg" value="Actualizar imagen" class="btn btn-dark" />
                            </div>
                        </div>
                    </div>
                }

            </div>
        </div>
    </div>
</div>
@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script src="~/Scripts/FuncionesAll/imagen_vista_previa.js"></script>
    <script src="~/Scripts/Validaciones/valida_imagen.js"></script>

    
    <script>
        $(document).ready(function () {

            $('#Ruta').change(function () {
                var filename = $('input[type=file]').val().replace(/C:\\fakepath\\/i, '')
                filename = filename.split('.').shift();
                $('#Nombre_imagen').val(filename);
                validaNombreEditarExiste();
            })
            $('#Nombre_imagen').blur(function () {
                validaNombreEditarExiste();
            });
            enviaValidaImagenEdicion('#btnEditarImg','Imagen editada');
        });
        function validaNombreEditarExiste() {
            if ($('#Nombre_imagen').val().trim() != '') {
                var valores = { Nombre_imagen: $('#Nombre_imagen').val().trim(), Id_imagen: $('#Id_imagen').val() };
                var resultado = JSON.stringify(valores);

                    $.ajax({
                        type: 'POST',
                        url: '@Url.Action("ExisteImagenEditar")',
                        data: resultado,
                        dataType: 'json',
                        contentType: 'application/json; charset=utf-8',
                        success: function (result) {
                            if (result != "") {
                                $('#Nombre_imagen').val('');
                                swal("Ya existe una imagen con ese nombre", "", "warning");
                            }
                        }
                    });
            }
        }

        estiloTab('a', 'nav-link active font-weight-bolder', '#imgNavLink', 'nav-link active font-weight-bolder');
       /* nav - link active font - weight - bolder*/
       
    </script>
}

FunXgame/FunXgame/Views/Imagenes/ListarImagen.cshtml
@model IEnumerable<FunXgame.Models.Imagen>
@{
    ViewBag.Title = "ListarImagen";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">
    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}


    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">

                    <li class="nav-item">
                        <a class="nav-link " style="color:white;background-color:black" href="~/Imagenes/ListarImagen">Listar imagenes</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Imagenes/CrearImagen">Agregar Imagenes</a>
                    </li>
                </ul>
            </div>
            <div class="card-body">
                <!--SELECTOR FILTROS-->
                <div class="form-row">
                    <div class="col-3 form-group">
                        <input class="form-control" type="text" id="Id_imagen" value="" placeholder="Id imagen" />
                    </div>
                    <div class="col-3 form-group">
                        <input class="form-control" type="text" id="Nombre_imagen" value="" placeholder="Nombre imagen" />
                    </div>
                    <div class="col-3">
                        @Html.DropDownList("grupoImagen", null, "Todos", htmlAttributes: new { @class = "form-control", id = "Grupo_imagen" })
                    </div>
                    <div>
                        <button class="btn btn-dark" id="buscar">Buscar</button>
                    </div>
                </div>
                <div class="table-responsive" id="tablaImagenes">
                    <!--AQUI PARA FUNCION LISTADO VISTA PARCIAL-->
                    <!--ESTO VA EN VISTA PARCIAL-->
                </div>
            </div>
        </div>
    </div>
</div>



@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    
    <script>

        $(window).on("load", function () {
            cargaTablaImagenes();
             
         });

        $('#buscar').click(function () {
            cargaTablaImagenes();
            $(this).blur();
        });

        function cargaTablaImagenes() {
            let datos = '?id=' + $('#Id_imagen').val() + '&nombre=' + $('#Nombre_imagen').val() + '&grupo=' + $('#Grupo_imagen').val();
                $.get('@Url.Action("ListarImagenPartial")' + datos, function (lista) {
                    $('#tablaImagenes').html(lista);
                });
        }
        
        
    </script>
}

FunXgame/FunXgame/Views/Imagenes/_ListarImagenPartial.cshtml
@model IEnumerable<FunXgame.Models.Imagen>

<form>
    <table class="table">
        <tr>
            <th>
                <label>Id</label>
            </th>
            <th>
                <label>Nombre imagen</label>
            </th>
            <th>
                <label>Vista Previa</label>
            </th>
            <th>
                <label>Grupo de imagen</label>
            </th>
            <th></th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Id_imagen)
                </td>

                <td>
                    @Html.DisplayFor(modelItem => item.Nombre_imagen)
                </td>
                <td>
                    <img src="@Url.Content(item.Ruta)" style="height:100px" />

                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Grupo_Imagen.Nombre_grupo)
                </td>
                <td>
                    <a class="btn btn-success" href="~/Imagenes/EditarImagen/@item.Id_imagen" id="">Editar</a>
                   

                </td>
                <td>
                    <input type="button" id="@item.Id_imagen" data-url="@Url.Action("Imagenes","EliminarImagen",new{id=item.Id_imagen})" value="Eliminar" class="btn btn-danger" />
                </td>
            </tr>
        }

    </table>
</form>
<script>

    @foreach(var item in Model)
     {
        <text>
           $('#@item.Id_imagen').click(function () {
               idCapturada = @item.Id_imagen;
               ConfirmaBorrar(idCapturada);
            });
     </Text>
     }

    function ConfirmaBorrar(idCapturada) {

        swal({
            title: "Está a punto de eliminar un achivo de imagen",
            text: "No será capaz de recuperarlo",
            icon: "warning",
            buttons: [
                'Cancelar',
                'Confirmar'
            ],
            dangerMode: true,
        }).then(function (isConfirm) {
            if (isConfirm) {
                var valores = { id: idCapturada };
                var resultado = JSON.stringify(valores);
                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("EliminarImagen")',
                    data: resultado,
                    dataType: 'json',
                    contentType: 'application/json; charset=utf-8',
                    success: function (result) {
                        if (result == "") {
                            swal({
                                title: 'Archivo de imagen eliminado',
                                icon: 'success'
                            }).then(function () {
                                cargaTablaImagenes(); 
                            });

                        } else {
                            swal("No se pudo eliminar la imagen", "error", "error");
                        }
                    }
                })
            }
        })
    }

</script>